////////////////////////////////////////////////////////////////////////////////////////////////////
// Http request setup to read or write Variables in a KAS Software
//
// DISCLAIMER:
// All programs in this release are provided "AS IS, WHERE IS", WITHOUT ANY WARRANTIES, EXPRESS OR IMPLIED.
// There may be technical OR editorial omissions in the programs AND their specifications.
// These programs are provided solely FOR user application development AND user assumes all responsibility FOR their use. Programs AND their content are subject TO change without notice.
//
// Version  When        Who         What
// ---------------------------------------------
//  0.001   24.02.17    MRupf KM    First Version
////////////////////////////////////////////////////////////////////////////////////////////////////

package com.kollmorgen.kasiface;

import android.os.AsyncTask;

import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;

// Async Http request class
public class HttpRequestTask extends AsyncTask<String, Void, String> {
    public interface AsyncResponse {
        void AsyncResponse(String str_Result);
    }

    public AsyncResponse delegate = null;
    public HttpRequestTask(AsyncResponse delegate){
        this.delegate = delegate;
    }

    @Override
    protected void onPostExecute(String result) {
        delegate.AsyncResponse(result);
    }

    // Use Background task to GET&PUT http commands
    @Override
    protected String doInBackground(String... strParam){
        // Return value dummy
        String str_ReturnValue = "no value";
        try {
            // Setup http web address
            String TempUrl ="http://" + strParam[0] + "/kas/plcvariables?variables=" + strParam[1] + "&format=text";
            URL ReqUrl = new URL(TempUrl);
            HttpURLConnection HttpReqConnection = (HttpURLConnection) ReqUrl.openConnection();

            // Check if value is read or write
            if(strParam.length == 3 ) {
                String TempParam = strParam[1] + "=" + strParam[2];
                //byte[] ParamStream = TempParam.getBytes();
                HttpReqConnection.setRequestMethod("PUT");
                OutputStreamWriter WriteStream = new OutputStreamWriter(HttpReqConnection.getOutputStream());
                WriteStream.write(TempParam);
                WriteStream.close();
            } else {
                HttpReqConnection.setRequestMethod("GET");
            }
            // Read http answer
            InputStream ReadStream = new BufferedInputStream(HttpReqConnection.getInputStream());
            BufferedReader ReadBuffer = new BufferedReader(new InputStreamReader(ReadStream));
            str_ReturnValue = ReadBuffer.readLine();
            // Close connection
            HttpReqConnection.disconnect();

        } catch (IOException e) {
            e.printStackTrace();
        }
        // Dummy return, as this task is done async, The AsyncResponse interface handles the return value
        return str_ReturnValue;
    }
}
