package com.kollmorgen.kasiface;

import android.graphics.Color;
import android.hardware.SensorManager;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Handler;
import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.View;
import android.view.inputmethod.InputMethodManager;
import android.widget.Button;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.TextView;
import android.widget.EditText;
import android.content.DialogInterface;

import com.google.android.gms.appindexing.Action;
import com.google.android.gms.appindexing.AppIndex;
import com.google.android.gms.appindexing.Thing;
import com.google.android.gms.common.api.GoogleApiClient;

import java.util.Objects;

public class MainActivity extends AppCompatActivity {

    /**
     * ATTENTION: This was auto-generated to implement the App Indexing API.
     * See https://g.co/AppIndexing/AndroidStudio for more information.
     */
    private GoogleApiClient client;
    public boolean bEstopState;
    public boolean bWriteMachineStateActive;    // Do not set the machine state radio button if they are written
    public String strIpAddr = "10.155.90.64";   // Default IP-address
    public boolean bWriteTravelSpeed;
    public boolean bWriteAbsMovePos;
    public boolean bWriteRelMovePos;
    public boolean bWriteMachineSpeed;
    public boolean bWriteUserDefVar;


    @Override
    protected void onCreate(Bundle savedInstanceState)  {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        // ATTENTION: This was auto-generated to implement the App Indexing API.
        // See https://g.co/AppIndexing/AndroidStudio for more information.
        client = new GoogleApiClient.Builder(this).addApi(AppIndex.API).build();

        final InputMethodManager KeyboardManager = (InputMethodManager) getSystemService(INPUT_METHOD_SERVICE);

        // Use an Alert Dialog at startup to get the correct IP-Address
        AlertDialog.Builder alertGetIpAddr = new AlertDialog.Builder(this);
        alertGetIpAddr.setTitle("Enter the PxMM IP-Address");
        // Set an EditText view to get user input
        final EditText input = new EditText(this);
        input.setText(strIpAddr);
        alertGetIpAddr.setView(input);
        alertGetIpAddr.setPositiveButton("Ok", new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog, int whichButton) {
                strIpAddr = input.getText().toString();
            }
        });
        alertGetIpAddr.show();

        //      *** Write KAS Variable ***
        // Push button1 -> EStop
        final Button PushButton1 = (Button) findViewById(R.id.button1);
        PushButton1.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                String TempWriteValue = String.valueOf(!bEstopState);
                AsyncTask<String, Void, String> WriteKasVar_bEStop = new HttpRequestTask(new HttpRequestTask.AsyncResponse() {
                    @Override
                    public void AsyncResponse(String str_Result) {
                        PushButton1.setBackgroundColor(Color.RED);
                        PushButton1.invalidate();
                        //Nothing to return on a push button write
                    }
                }).execute(strIpAddr, "bEstop", TempWriteValue);
            }
        });

        // Write machine state according to radio group
        final RadioGroup RadioGroupMcState = (RadioGroup) findViewById(R.id.radioGroupMcState);
        final RadioButton RadioModeOff = (RadioButton) findViewById(R.id.radioButton3);
        RadioGroupMcState.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged (RadioGroup rg, int CheckRadioButtonId){
                bWriteMachineStateActive = true;
                // Calculate the MachineState Value 0 = Off, 1 = Manual, 2 = Automatic
                int TempWriteValue = (CheckRadioButtonId - RadioModeOff.getId()) * -1;
                AsyncTask<String, Void, String> WriteKasVar_MachineState = new HttpRequestTask(new HttpRequestTask.AsyncResponse() {
                    @Override
                    public void AsyncResponse(String str_Result) {
                        bWriteMachineStateActive = false;
                    }
            }).execute(strIpAddr, "MachineState", Integer.toString(TempWriteValue));
            }
        });

        // Write Travel Speed
        final EditText TextTravelSpeed = (EditText) findViewById(R.id.InputTravelSpeed);
        TextTravelSpeed.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                bWriteTravelSpeed = true;
            }
        });
        TextTravelSpeed.setOnKeyListener(new View.OnKeyListener() {
            @Override
            public boolean onKey(View view, int keyCode, KeyEvent keyEvent) {
                String TempWriteValue;
                bWriteTravelSpeed = true;
                if (keyCode == KeyEvent.KEYCODE_ENTER) {
                    TempWriteValue = TextTravelSpeed.getText().toString();
                    AsyncTask<String, Void, String> WriteKasVar_TravelSpeed = new HttpRequestTask(new HttpRequestTask.AsyncResponse() {
                        @Override
                        public void AsyncResponse(String str_Result) {
                            bWriteTravelSpeed = false;
                        }
                    }).execute(strIpAddr, "TravelSpeed", TempWriteValue);
                    TextTravelSpeed.clearFocus();
                    KeyboardManager.hideSoftInputFromWindow(TextTravelSpeed.getWindowToken(), 0);
                    return true;
                }
                return false;
            }
        });
        TextTravelSpeed.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View view, boolean bHasFocus) {
                if (!bHasFocus) {
                    bWriteTravelSpeed = false;
                }
            }
        });

        // Write absolute move target position
        final EditText TextAbsMove = (EditText) findViewById(R.id.InputMoveAbs);
        TextAbsMove.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                bWriteAbsMovePos = true;
            }
        });
        TextAbsMove.setOnKeyListener(new View.OnKeyListener() {
            @Override
            public boolean onKey(View view, int keyCode, KeyEvent keyEvent) {
                String TempWriteValue;
                bWriteAbsMovePos = true;
                if (keyCode == KeyEvent.KEYCODE_ENTER) {
                    TempWriteValue = TextAbsMove.getText().toString();
                    AsyncTask<String, Void, String> WriteKasVar_AbsPos = new HttpRequestTask(new HttpRequestTask.AsyncResponse() {
                        @Override
                        public void AsyncResponse(String str_Result) {
                        }
                    }).execute(strIpAddr, "MasterAbsPos", TempWriteValue);
                    TextAbsMove.clearFocus();
                    KeyboardManager.hideSoftInputFromWindow(TextTravelSpeed.getWindowToken(), 0);
                    return true;
                }
                return false;
            }
        });
        TextAbsMove.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View view, boolean bHasFocus) {
                if (!bHasFocus) {
                    bWriteAbsMovePos = false;
                }
            }
        });
        // Push button -> bMasterAbs
        final Button PushButtonMoveAbs = (Button) findViewById(R.id.ButtonMoveAbs);
        PushButtonMoveAbs.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                WriteBoolTrueFalse("bMasterAbs", true);
            }
        });

        // Write relative move distance
        final EditText TextRelMove = (EditText) findViewById(R.id.InputMoveRel);
        TextRelMove.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                bWriteRelMovePos = true;
            }
        });
        TextRelMove.setOnKeyListener(new View.OnKeyListener() {
            @Override
            public boolean onKey(View view, int keyCode, KeyEvent keyEvent) {
                String TempWriteValue;
                bWriteRelMovePos = true;
                if (keyCode == KeyEvent.KEYCODE_ENTER) {
                    TempWriteValue = TextRelMove.getText().toString();
                    AsyncTask<String, Void, String> WriteKasVar_RelPos = new HttpRequestTask(new HttpRequestTask.AsyncResponse() {
                        @Override
                        public void AsyncResponse(String str_Result) {
                        }
                    }).execute(strIpAddr, "MasterDeltaPos", TempWriteValue);
                    TextRelMove.clearFocus();
                    KeyboardManager.hideSoftInputFromWindow(TextTravelSpeed.getWindowToken(), 0);
                    return true;
                }
                return false;
            }
        });
        TextRelMove.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View view, boolean bHasFocus) {
                if (!bHasFocus) {
                    bWriteRelMovePos = false;
                }
            }
        });
        // Push button -> bMasterRel
        final Button PushButtonMoveRel = (Button) findViewById(R.id.ButtonMoveRel);
        PushButtonMoveRel.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                WriteBoolTrueFalse("bMasterRel", true);
            }
        });

        // Write Machine Speed
        final EditText TextMachineSpeed = (EditText) findViewById(R.id.InputMachineSpeed);
        TextMachineSpeed.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                bWriteMachineSpeed = true;
            }
        });
        TextMachineSpeed.setOnKeyListener(new View.OnKeyListener() {
            @Override
            public boolean onKey(View view, int keyCode, KeyEvent keyEvent) {
                String TempWriteValue;
                bWriteMachineSpeed = true;
                if (keyCode == KeyEvent.KEYCODE_ENTER) {
                    TempWriteValue = TextMachineSpeed.getText().toString();
                    AsyncTask<String, Void, String> WriteKasVar_MachineSpeed = new HttpRequestTask(new HttpRequestTask.AsyncResponse() {
                        @Override
                        public void AsyncResponse(String str_Result) {
                        }
                    }).execute(strIpAddr, "MachineSpeed", TempWriteValue);
                    TextMachineSpeed.clearFocus();
                    KeyboardManager.hideSoftInputFromWindow(TextTravelSpeed.getWindowToken(), 0);
                    return true;
                }
                return false;
            }
        });
        TextMachineSpeed.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View view, boolean bHasFocus) {
                if (!bHasFocus) {
                    bWriteMachineSpeed = false;
                }
            }
        });

        // User defined variable
        final Button PushButtonUserDefVar = (Button) findViewById(R.id.ButtonUserDefVar);
        // Toggle Read or write mode
        PushButtonUserDefVar.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                if(bWriteUserDefVar) {
                    PushButtonUserDefVar.setText("Read Variable");
                } else {
                    PushButtonUserDefVar.setText("Write Variable");
                }
                bWriteUserDefVar = !bWriteUserDefVar;
            }
        });
        // Write User defined variable
        final EditText TextUserDefVar = (EditText) findViewById(R.id.TextUserDefVar);
        final EditText ValueUserDefVar = (EditText) findViewById(R.id.InputUserDefVar);
        ValueUserDefVar.setOnKeyListener(new View.OnKeyListener() {
            @Override
            public boolean onKey(View view, int keyCode, KeyEvent keyEvent) {
                String TempWriteValue;
                bWriteMachineSpeed = true;
                if (keyCode == KeyEvent.KEYCODE_ENTER) {
                    TempWriteValue = ValueUserDefVar.getText().toString();
                    AsyncTask<String, Void, String> WriteKasVar_UserDefVar = new HttpRequestTask(new HttpRequestTask.AsyncResponse() {
                        @Override
                        public void AsyncResponse(String str_Result) {
                        }
                    }).execute(strIpAddr, TextUserDefVar.getText().toString(), ValueUserDefVar.getText().toString());
                    ValueUserDefVar.clearFocus();
                    KeyboardManager.hideSoftInputFromWindow(TextTravelSpeed.getWindowToken(), 0);
                    return true;
                }
                return false;
            }
        });

        //          *** END Write KAS variable section ***

        // Do a runnable with a cyclic call for ReadKasVar
        final Handler MainHandler = new Handler();
        Runnable r = new Runnable() {
            @Override
            public void run() {
                // Read all variable
                ReadKasVar();
                // Do a cyclic call of the read function all 250ms
                MainHandler.postDelayed(this, 250);
            }
        };
        // Init the reading for the first call
        MainHandler.post(r);

    }

    // Special write function
    // After writing 1 automatically write 0 (create a bool rising edge)
    public void WriteBoolTrueFalse(final String strParameter, final boolean bMoveBit) {
        AsyncTask<String, Void, String> WriteKasVar_MoveRel = new HttpRequestTask(new HttpRequestTask.AsyncResponse() {
            @Override
            public void AsyncResponse(String str_Result) {
                if (bMoveBit) {
                    WriteBoolTrueFalse(strParameter, false);
                }
            }
        }).execute(strIpAddr, strParameter, Boolean.toString(bMoveBit));
    }

    //      *** READ KAS Variable ***
    // Create a cyclic main and start it in the onCreate
    public void ReadKasVar() {

        // Read bEStop and color button
        final Button PushButton1 = (Button) findViewById(R.id.button1);
        AsyncTask<String, Void, String> ReadKasVar_bEStop = new HttpRequestTask(new HttpRequestTask.AsyncResponse() {
            @Override
            public void AsyncResponse(String str_Result) {
                if (Objects.equals(str_Result, "0")){
                    bEstopState = false;
                    PushButton1.setBackgroundColor(Color.GREEN);
                }else{
                    bEstopState = true;
                    PushButton1.setBackgroundColor(Color.RED);
                }
            }
        }).execute(strIpAddr, "bEStop");

        // Read MachineState and set RadioGroup
        final RadioButton RadioModeAuto = (RadioButton) findViewById(R.id.radioButton1);
        final RadioButton RadioModeMan = (RadioButton) findViewById(R.id.radioButton2);
        final RadioButton RadioModeOff = (RadioButton) findViewById(R.id.radioButton3);
        AsyncTask<String, Void, String> ReadKasVar_MachineState = new HttpRequestTask(new HttpRequestTask.AsyncResponse() {
            @Override
            public void AsyncResponse(String str_Result) {
                if (!bWriteMachineStateActive) {
                    if (Objects.equals(str_Result, "0")) {
                        RadioModeOff.setChecked(true);
                    } else if (Objects.equals(str_Result, "1")) {
                        RadioModeMan.setChecked(true);
                    } else if (Objects.equals(str_Result, "2")) {
                        RadioModeAuto.setChecked(true);
                    }
                }
            }
        }).execute(strIpAddr, "MachineState");

        // Read Travel speed
        final EditText TextTravelSpeed = (EditText) findViewById(R.id.InputTravelSpeed);
        AsyncTask<String, Void, String> ReadKasVar_TravelSpeed = new HttpRequestTask(new HttpRequestTask.AsyncResponse() {
            @Override
            public void AsyncResponse(String str_Result) {
                if (!bWriteTravelSpeed) {
                    TextTravelSpeed.setText(str_Result);
                }
            }
        }).execute(strIpAddr, "TravelSpeed");

        // Read Travel speed
        final EditText TextAbsMove = (EditText) findViewById(R.id.InputMoveAbs);
        AsyncTask<String, Void, String> ReadKasVar_AbsMove = new HttpRequestTask(new HttpRequestTask.AsyncResponse() {
            @Override
            public void AsyncResponse(String str_Result) {
                if (!bWriteAbsMovePos) {
                    TextAbsMove.setText(str_Result);
                }
            }
        }).execute(strIpAddr, "MasterAbsPos");

        // Read Travel speed
        final EditText TextRelMove = (EditText) findViewById(R.id.InputMoveRel);
        AsyncTask<String, Void, String> ReadKasVar_RelMove = new HttpRequestTask(new HttpRequestTask.AsyncResponse() {
            @Override
            public void AsyncResponse(String str_Result) {
                if (!bWriteRelMovePos) {
                    TextRelMove.setText(str_Result);
                }
            }
        }).execute(strIpAddr, "MasterDeltaPos");

        // Read Machine speed
        final EditText TextMachineSpeed = (EditText) findViewById(R.id.InputMachineSpeed);
        AsyncTask<String, Void, String> ReadKasVar_MachineSpeed = new HttpRequestTask(new HttpRequestTask.AsyncResponse() {
            @Override
            public void AsyncResponse(String str_Result) {
                if (!bWriteMachineSpeed) {
                    TextMachineSpeed.setText(str_Result);
                }
            }
        }).execute(strIpAddr, "MachineSpeed");

        // Read User defined variable
        final EditText TextUserDefVar = (EditText) findViewById(R.id.TextUserDefVar);
        final EditText ValueUserDefVar = (EditText) findViewById(R.id.InputUserDefVar);
        AsyncTask<String, Void, String> ReadKasVar_UserDefVar = new HttpRequestTask(new HttpRequestTask.AsyncResponse() {
            @Override
            public void AsyncResponse(String str_Result) {
                if (!bWriteUserDefVar) {
                    ValueUserDefVar.setText(str_Result);
                }
            }
        }).execute(strIpAddr, TextUserDefVar.getText().toString());

    }

    /**
     * ATTENTION: This was auto-generated to implement the App Indexing API.
     * See https://g.co/AppIndexing/AndroidStudio for more information.
     */
    public Action getIndexApiAction() {
        Thing object = new Thing.Builder()
                .setName("Main Page") // TODO: Define a title for the content shown.
                // TODO: Make sure this auto-generated URL is correct.
                .setUrl(Uri.parse("http://[ENTER-YOUR-URL-HERE]"))
                .build();
        return new Action.Builder(Action.TYPE_VIEW)
                .setObject(object)
                .setActionStatus(Action.STATUS_TYPE_COMPLETED)
                .build();
    }

    @Override
    public void onStart() {
        super.onStart();

        // ATTENTION: This was auto-generated to implement the App Indexing API.
        // See https://g.co/AppIndexing/AndroidStudio for more information.
        client.connect();
        AppIndex.AppIndexApi.start(client, getIndexApiAction());
    }

    @Override
    public void onStop() {
        super.onStop();

        // ATTENTION: This was auto-generated to implement the App Indexing API.
        // See https://g.co/AppIndexing/AndroidStudio for more information.
        AppIndex.AppIndexApi.end(client, getIndexApiAction());
        client.disconnect();
    }

}
